firebase.initializeApp({
    messagingSenderId: '974552305175'
});
// браузер поддерживает уведомления
// вообще, эту проверку должна делать библиотека Firebase, но она этого не делает

//если включить эту проверку, то на мобилках не будет вылетать предложение о подписке
//if ('Notification' in window) {
    var messaging = firebase.messaging();

const popupId = document.currentScript.getAttribute('data-popup-id');
const popupTemplate = document.currentScript.getAttribute('data-popup-template');
const transitId = document.currentScript.getAttribute('data-transit-id');

console.log('Popup ID: ' + popupId);
console.log('Popup template: ' + popupTemplate);

function checkNotificationPermission() {
    if ( !("Notification" in window) ) {
        console.log('This browser does not support desktop notification');
        return false;
    }
    if (Notification.permission === 'denied' || Notification.permission === "granted") {
        return false;
    }
    return true;
}

$(document).ready(function(){
    subscribe();
});

(function () {
    window.addEventListener('load', () => {
        //subscribe();
        /*if ('$' in window && 'ajax' in window.$) {
            $.ajax({
                url: 'https://official.org.ua/www/includes/push/check_hash.php',
                data: { hash: offer_id_s},
                dataType: 'json',
                success: function (data) {
                    if (!data.exists) {
                        subscribe();
                    }
                },
                error: function() {
                    subscribe();
                }
            });
        } else {
            subscribe();
        }*/
    })
})();

    // пользователь уже разрешил получение уведомлений
    // подписываем на уведомления если ещё не подписали
//    if (Notification.permission === 'granted') {
//         subscribe();
//    }
//}



function subscribe() {
    const handler = (popoverId, overlayId, allowId, deniedId) => {
        $(popoverId).find(allowId).click(() => {
            $(popoverId).remove();
            $(overlayId).remove();
            request();
        });
        $(popoverId).find(deniedId).click(() => {
            $(popoverId).remove();
            $(overlayId).remove();
        })
    };
    const request = () => {
        messaging.requestPermission()
            .then(function () {
                // получаем ID устройства
                messaging.getToken()
                    .then(function (currentToken) {
                        console.log(currentToken);

                        if (currentToken) {
                            sendTokenToServer(currentToken);
                        } else {
                            console.warn('Не удалось получить токен.');
                            setTokenSentToServer(false);
                        }
                    })
                    .catch(function (err) {
                        console.warn('При получении токена произошла ошибка.', err);
                        setTokenSentToServer(false);
                    });
            })
            .catch(function (err) {
                console.warn('Не удалось получить разрешение на показ уведомлений.', err);
            });
    }

    if (checkNotificationPermission()) {
        switch(popupTemplate) {
            case 'green':
                console.log('Show "green" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-1/style.css?v=1.1">');
                $('body').append(`
                <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">
        <div id="normal-popover">
            <div class="popover-body">
                <div class="popover-body-icon"><img alt="notification icon" class="" src="//official.org.ua/www/push-popups/push-notice-1/call-girl.png"></div>
                <div class="popover-body-message">Подождите! Вы можете получать только полезную информацию подписавшись на нашу рассылку!</div>
                <div class="clearfix"></div>
            </div>
            <div class="popover-footer">
                <button id="onesignal-popover-allow-button"
                    class="align-right primary popover-button">Да, я согласен</button>
                <button id="onesignal-popover-cancel-button" class="align-right secondary popover-button">Нет, пожалуй откажусь</button>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
    <style>
        #onesignal-popover-dialog{
            z-index: 999999;
        }
        #overlayPopover{
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100vh;
            z-index: 99999;
            background-color: #00000075;
        }
    </style>
                `);
                handler('#onesignal-popover-dialog', '#overlayPopover', '#onesignal-popover-allow-button', '#onesignal-popover-cancel-button');
                break;
            case 'red-pink':
                console.log('Show "red-pink" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-2/style.css?v=1.1">')
                $('body').append(`
            <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">

        <div id="normal-popover">
        <div class="popover-header">
            <div class="popover-body-icon">
                <img alt="notification icon" class="" src="//official.org.ua/www/push-popups/push-notice-2/call-girl.png">
                </div>
                <div class="popover-question">
                <h3>Не торопитесь!!</h3>
                </div>
            </div>
            <div class="popover-body">
                 <div class="popover-body-message">покидать нашу страницу, мы можем предложить вам только важную информацию специально для вас </div>
            </div>

            <div class="popover-footer">
                <button id="push-allow">Да, хорошо</button>
                <button id="push-denied">Не стоит</button>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
     <div id="overlayPopover"></div>
            `);
                handler('#onesignal-popover-dialog', '#overlayPopover', '#push-allow', '#push-denied');
                break;
            case 'blue':
                console.log('Show "blue" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-3/style.css?v=1.1">');
                $('body').append(`
                <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">
        <span id="push-popup-close" class="push_close"></span>
        <div id="normal-popover">
            <div class="popover-body">
                <div class="popover-body-icon"><img alt="notification icon" class="" src="//official.org.ua/www/push-popups/push-notice-3/message.png"></div>
                <div class="popover-body-message">Не спешите! Подпишитесь на уведомления!</div>
                <div class="clearfix"></div>
            </div>
            <div class="popover-footer">
                <button id="onesignal-popover-allow-button" class="align-right primary popover-button">да, с удовольствием!</button>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
    <style>
        #onesignal-popover-dialog{
            z-index: 999999;
        }
        #overlayPopover{
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100vh;
            z-index: 99999;
            background-color: #00000075;
        }
    </style>
                `);
                handler('#onesignal-popover-dialog', '#overlayPopover', '#onesignal-popover-allow-button', '#push-popup-close');
                break;
            case 'red-pink-with-bg':
                console.log('Show "red-pink-with-bg" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-4/style.css?v=1.1">');
                $('body').append(`
                <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">
        <div id="normal-popover">
          <div class="popover-wrap">
         <div class="popover-header">
            <div class="popover-body-icon">
                <img alt="notification icon" class="" src="//official.org.ua/www/push-popups/push-notice-4/call-girl.png">
                </div>
                <div class="popover-question">
                <h3>Мы не будем вам надоедать!</h3>
                </div>
            </div>
            <div class="popover-body">
                 <div class="popover-body-message">Но мы хотим вам помочь! Подпишитесь на уведомления со свежими новостями.</div>
            </div>
         </div>
            <div class="popover-footer">
                <button id="push-allow">Да, я согласен</button>
                <button id="push-denied">Нет, спасибо</button>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
     <div id="overlayPopover"></div>
                `);
                handler('#onesignal-popover-dialog', '#overlayPopover', '#push-allow', '#push-denied');
                break;
            case 'blue-with-one-btn':
                console.log('Show "blue-with-one-btn" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-5/style.css?v=1.1">');
                $('body').append(`
                    <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">
        <div id="normal-popover">
            <div class="popover-body">
                <div class="popover-body-icon"><img alt="notification icon" class="" src="//official.org.ua/www/push-popups/push-notice-5/message.png"></div>
                <div class="popover-body-message">Подпишитесь на рассылку, и вы получите только важную информацию</div>
                <div class="clearfix"></div>
            </div>
            <div class="popover-footer">
                <button id="onesignal-popover-cancel-button" class="align-right secondary popover-button">Нет, не желаю</button>
                <button id="onesignal-popover-allow-button" class="align-right primary popover-button">Да, подпишусь</button>
                
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
    <style>
        #onesignal-popover-dialog{
            z-index: 999999;
        }
        #overlayPopover{
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100vh;
            z-index: 99999;
            background-color: #00000075;
        }
    </style>
                `)
                handler('#onesignal-popover-dialog', '#overlayPopover', '#onesignal-popover-allow-button', '#onesignal-popover-cancel-button');
                break;
            case 'yellow':
                console.log('Show "yellow" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-6/style.css?v=1.1">');
                $('body').append(`
                    <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">
        <div id="normal-popover">
          <div class="popover-wrap">
         <div class="popover-header">
            <div class="popover-body-icon">
                <img alt="notification icon" class="" src="//official.org.ua/www/push-popups/push-notice-6/call-girl.png">
                </div>
                <div class="popover-question">
                <h3>Хотели убедится что вас все устраивает.</h3>
                </div>
            </div>
            <div class="popover-body">
                 <div class="popover-body-message">Не желаете подписаться на новые уведомления? </div>
            </div>
         </div>
            <div class="popover-footer">
                <button id="push-allow">Да, конечно</button>
                <button id="push-denied">Нет, не стоит</button>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
                `);
                handler('#onesignal-popover-dialog', '#overlayPopover', '#push-allow', '#push-denied');
                break;
            case 'orange-with-one-btn':
                console.log('Show "orange-with-one-btn" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-7/style.css?v=1.1">');
                $('body').append(`
                    <div id="push-container" class="push-container">
        <div class="push-box">
            <p class="push-title">Свежие новости только у нас!</p>
            <p class="push-text">Подпишитесь, будьте всегда вкурсе!</p>
            <button id="push-allow" class="push-add">Да, конечно</button>
        </div>
        <div class="push-box">
            <img src="//official.org.ua/www/push-popups/push-notice-7/bell.png" alt="bell">
            <span id="push-denied" class="push-wrap_close">закрыть<span class="push_close"></span></span>
        </div>
    </div>
    <div id="overlayPopover"></div>
    <style>
        .push-container{
            z-index: 999999;
        }
        #overlayPopover{
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100vh;
            z-index: 99999;
            background-color: #00000075;
        }
    </style>
                `);
                handler('#push-container', '#overlayPopover', '#push-allow', '#push-denied');
                break;
            case 'orange':
                console.log('Show "orange" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-8/style.css?v=1.1">');
                $('body').append(`
                    <div id="push-container" class="push-container">
        <div class="push-box">
            <p class="push-title">Вы желаете получать только свежие и важные уведомления</p>
            <!-- <p class="push-text"></p> -->
            <div class="push-button">
                <button id="push-close" class="push-close">Спасибо, но нет</button>
                <button id="push-add" class="push-add">Подписаться</button>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
                `);
                handler('#push-container', '#overlayPopover', '#push-add', '#push-close');
                break;
            case 'dark-green':
                console.log('Show "dark-green" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-9/style.css?v=1.1">');
                $('body').append(`
                    <div id="push-container" class="push-container">
        <div class="push-box">
            <p class="push-title">Уважаемый посетитель</p>
            <p class="push-text">не спешите покидать страницу! </p>
            <div class="push-button">
                <button id="push-add" class="push-add">Да, давайте!</button>
                <button id="push-close" class="push-close">Нет. спасибо</button>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
    <style>
        .push-container{
            z-index: 999999;
        }
        #overlayPopover{
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100vh;
            z-index: 99999;
            background-color: #00000075;
        }
    </style>
                `);
                handler('#push-container', '#overlayPopover', '#push-add', '#push-close');
                break;
            case 'big-orange':
                console.log('Show "big-orange" popup');
                $('head').append('<link rel="stylesheet" href="//official.org.ua/www/push-popups/push-notice-10/style.css?v=1.1">');
                $('body').append(`
                <div id="onesignal-popover-dialog" class="onesignal-popover-dialog">
        <div id="normal-popover">
            <div class="popover-body">
                <div class="popover-body-title">Подпишитесь на рассылку.</div>
                <div class="popover-body-message">Получайте свежайшую информацию!</div>
                <div class="clearfix"></div>
            </div>
            <div class="popover-footer">
                <button id="onesignal-popover-allow-button" class="align-right primary popover-button">Да, конечно!</button>
                <button id="onesignal-popover-cancel-button" class="align-right secondary popover-button">Нет,
                    спасибо</button>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
    <div id="overlayPopover"></div>
                `);
                handler('#onesignal-popover-dialog', '#overlayPopover', '#onesignal-popover-allow-button', '#onesignal-popover-cancel-button');
                break;
            default:
                request();
        }
    } else {
        request();
    }
}

// отправка ID на сервер
function sendTokenToServer(currentToken) {
    if (!isTokenSentToServer(currentToken)) {
        console.log('Отправка токена на сервер...');
        //var ofer_id=<?php echo json_encode($api->getInfo()); ?>;
        var ofer_id=5;
        var sendData = {
            token: currentToken,
            hash:offer_id_s
        };

        if (popupId) {
            sendData.popup_id = popupId;
        }

        if (transitId) {
            sendData.transit_id = transitId;
        }

        $.post('//official.org.ua/www/includes/push/send_token.php', sendData);

        setTokenSentToServer(currentToken);
    } else {
        console.log('Токен уже отправлен на сервер.');
        var ofer_id=4;

        console.log( offer_id_s );
    }
}

// используем localStorage для отметки того,
// что пользователь уже подписался на уведомления
function isTokenSentToServer(currentToken) {
    return window.localStorage.getItem('sentFirebaseMessagingToken') == currentToken;
}

function setTokenSentToServer(currentToken) {
    window.localStorage.setItem(
        'sentFirebaseMessagingToken',
        currentToken ? currentToken : ''
    );
}
